/// <reference types="react" />
import * as React from 'react';
import { InputProps, MetaProps } from 'redux-forms/lib/shared/fieldProps';
import { Value } from 'redux-forms/lib/shared/getValue';
import { ContextProps } from './connectField';
export declare type SuppliedProps = {
    input: InputProps;
    meta: MetaProps;
};
export declare type FieldProps<T> = T & {
    name: string;
    component: React.ComponentClass<T & SuppliedProps> | React.SFC<T & SuppliedProps> | string;
    validate?: Validate;
    normalize?: Normalize;
    defaultValue?: string;
    withRef?: (el: React.ReactElement<any>) => void;
};
export declare type Validate = (value: Value) => string | null;
export declare type Normalize = (value: Value) => Value;
declare const Contexted: React.StatelessComponent<{} & {
    name: string;
    component: string | React.ComponentClass<{} & SuppliedProps> | React.StatelessComponent<{} & SuppliedProps>;
    validate?: Validate | undefined;
    normalize?: Normalize | undefined;
    defaultValue?: string | undefined;
    withRef?: ((el: React.ReactElement<any>) => void) | undefined;
} & {
    name: string;
}> & {
    WrappedComponent?: React.ComponentClass<{} & {
        name: string;
        component: string | React.ComponentClass<{} & SuppliedProps> | React.StatelessComponent<{} & SuppliedProps>;
        validate?: Validate | undefined;
        normalize?: Normalize | undefined;
        defaultValue?: string | undefined;
        withRef?: ((el: React.ReactElement<any>) => void) | undefined;
    } & {
        name: string;
    } & ContextProps> | undefined;
};
export default Contexted;
