'use strict';

exports.__esModule = true;

var _path = require('ramda/src/path');

var _path2 = _interopRequireDefault(_path);

var _merge = require('ramda/src/merge');

var _merge2 = _interopRequireDefault(_merge);

var _map = require('ramda/src/map');

var _map2 = _interopRequireDefault(_map);

var _addIndex = require('ramda/src/addIndex');

var _addIndex2 = _interopRequireDefault(_addIndex);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _reactRedux = require('react-redux');

var _fieldArrayProps = require('redux-forms/lib/shared/fieldArrayProps');

var _fieldArrayProps2 = _interopRequireDefault(_fieldArrayProps);

var _helpers = require('redux-forms/lib/shared/helpers');

var _actions = require('redux-forms/actions');

var actions = _interopRequireWildcard(_actions);

var _connectField = require('./connectField');

var _connectField2 = _interopRequireDefault(_connectField);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RindexMap = (0, _addIndex2.default)(_map2.default);

var FieldArray = function (_React$PureComponent) {
    _inherits(FieldArray, _React$PureComponent);

    function FieldArray(props) {
        _classCallCheck(this, FieldArray);

        var _this = _possibleConstructorReturn(this, _React$PureComponent.call(this, props));

        _this.handleMap = _this.handleMap.bind(_this);
        _this.handlePush = _this.handlePush.bind(_this);
        _this.handlePop = _this.handlePop.bind(_this);
        _this.handleUnshift = _this.handleUnshift.bind(_this);
        _this.handleShift = _this.handleShift.bind(_this);
        _this.handleInsert = _this.handleInsert.bind(_this);
        _this.handleRemove = _this.handleRemove.bind(_this);
        _this.handleSwap = _this.handleSwap.bind(_this);
        _this.handleMove = _this.handleMove.bind(_this);
        return _this;
    }

    FieldArray.prototype.componentWillMount = function componentWillMount() {
        var _props = this.props,
            _form = _props._form,
            name = _props.name,
            _array = _props._array,
            _addArray = _props._addArray;

        if (!_array) {
            _addArray(_form, name);
        }
    };

    FieldArray.prototype.componentWillUnmount = function componentWillUnmount() {
        var _props2 = this.props,
            _form = _props2._form,
            name = _props2.name,
            _removeArray = _props2._removeArray;

        _removeArray(_form, name);
    };

    FieldArray.prototype.handleMap = function handleMap(fn) {
        var _props3 = this.props,
            name = _props3.name,
            _array = _props3._array;

        var array = Array.from(Array(_array));
        return RindexMap(fn, RindexMap(function (_, i) {
            return name + '.' + i;
        }, array));
    };

    FieldArray.prototype.handlePush = function handlePush(ev) {
        var _props4 = this.props,
            _form = _props4._form,
            name = _props4.name,
            _arrayPush = _props4._arrayPush;

        if ((0, _helpers.isEvent)(ev)) {
            ev.preventDefault();
        }
        _arrayPush(_form, name);
    };

    FieldArray.prototype.handlePop = function handlePop(ev) {
        var _props5 = this.props,
            _form = _props5._form,
            name = _props5.name,
            _array = _props5._array,
            _arrayPop = _props5._arrayPop;

        if ((0, _helpers.isEvent)(ev)) {
            ev.preventDefault();
        }
        if (_array > 0) {
            _arrayPop(_form, name);
        }
    };

    FieldArray.prototype.handleUnshift = function handleUnshift(ev) {
        var _props6 = this.props,
            _form = _props6._form,
            name = _props6.name,
            _arrayUnshift = _props6._arrayUnshift;

        if ((0, _helpers.isEvent)(ev)) {
            ev.preventDefault();
        }
        _arrayUnshift(_form, name);
    };

    FieldArray.prototype.handleShift = function handleShift(ev) {
        var _props7 = this.props,
            _form = _props7._form,
            name = _props7.name,
            _array = _props7._array,
            _arrayShift = _props7._arrayShift;

        if ((0, _helpers.isEvent)(ev)) {
            ev.preventDefault();
        }
        if (_array > 0) {
            _arrayShift(_form, name);
        }
    };

    FieldArray.prototype.handleInsert = function handleInsert(index) {
        var _props8 = this.props,
            _form = _props8._form,
            name = _props8.name,
            _arrayInsert = _props8._arrayInsert;

        _arrayInsert(_form, name, index);
    };

    FieldArray.prototype.handleRemove = function handleRemove(index) {
        var _props9 = this.props,
            _form = _props9._form,
            name = _props9.name,
            _arrayRemove = _props9._arrayRemove;

        _arrayRemove(_form, name, index);
    };

    FieldArray.prototype.handleSwap = function handleSwap(index1, index2) {
        var _props10 = this.props,
            _form = _props10._form,
            name = _props10.name,
            _arraySwap = _props10._arraySwap;

        _arraySwap(_form, name, index1, index2);
    };

    FieldArray.prototype.handleMove = function handleMove(from, to) {
        var _props11 = this.props,
            _form = _props11._form,
            name = _props11.name,
            _arrayMove = _props11._arrayMove;

        _arrayMove(_form, name, from, to);
    };

    FieldArray.prototype.render = function render() {
        var _props12 = this.props,
            component = _props12.component,
            withRef = _props12.withRef,
            _array = _props12._array;

        if (!(0, _helpers.isNumber)(_array)) {
            return null;
        }
        // React.SFC vs. React.ClassComponent collision
        return React.createElement(component, (0, _fieldArrayProps2.default)((0, _merge2.default)(this.props, { ref: withRef }), {
            length: _array,
            map: this.handleMap,
            push: this.handlePush,
            pop: this.handlePop,
            unshift: this.handleUnshift,
            shift: this.handleShift,
            insert: this.handleInsert,
            remove: this.handleRemove,
            swap: this.handleSwap,
            move: this.handleMove
        }));
    };

    return FieldArray;
}(React.PureComponent);

FieldArray.propTypes = {
    name: React.PropTypes.string.isRequired,
    component: React.PropTypes.func.isRequired
};
FieldArray.displayName = 'FieldArray';
var bindActions = {
    _addArray: actions.addArray,
    _removeArray: actions.removeArray,
    _arrayPush: actions.arrayPush,
    _arrayPop: actions.arrayPop,
    _arrayUnshift: actions.arrayUnshift,
    _arrayShift: actions.arrayShift,
    _arrayInsert: actions.arrayInsert,
    _arrayRemove: actions.arrayRemove,
    _arraySwap: actions.arraySwap,
    _arrayMove: actions.arrayMove
};
var Connected = (0, _reactRedux.connect)(function (state, props) {
    return {
        _array: (0, _path2.default)([props._form, 'arrays', props.name], state.reduxForms)
    };
}, bindActions)(FieldArray);
var Contexted = (0, _connectField2.default)(Connected);
Contexted.displayName = FieldArray.displayName;
exports.default = Contexted;