/// <reference types="react" />
import * as React from 'react';
import * as actions from 'redux-forms/actions';
export interface IFormProps extends React.HTMLProps<HTMLFormElement> {
    name: string;
    persistent?: boolean;
    onSubmit?: (values: Object) => Promise<any> | void;
    withRef?: (el: HTMLFormElement) => void;
}
export declare type Context = {
    reduxForms: string;
};
export declare type StateProps = {
    _form: boolean;
    _values: Object;
    _valid: boolean;
    _submitting: boolean;
};
export declare type ActionProps = {
    _addForm: actions.AddFormCreator;
    _removeForm: actions.RemoveFormCreator;
    _touchAll: actions.TouchAllCreator;
    _submitStart: actions.SubmitStartCreator;
    _submitStop: actions.SubmitStopCreator;
};
export declare type Props<T> = StateProps & ActionProps & IFormProps & T;
declare const Connected: React.ComponentClass<IFormProps>;
export default Connected;
