'use strict';

exports.__esModule = true;

var _prop = require('ramda/src/prop');

var _prop2 = _interopRequireDefault(_prop);

var _merge = require('ramda/src/merge');

var _merge2 = _interopRequireDefault(_merge);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _reactRedux = require('react-redux');

var _helpers = require('redux-forms/lib/shared/helpers');

var _formProps = require('redux-forms/lib/shared/formProps');

var _formProps2 = _interopRequireDefault(_formProps);

var _actions = require('redux-forms/actions');

var actions = _interopRequireWildcard(_actions);

var _selectors = require('redux-forms/selectors');

var selectors = _interopRequireWildcard(_selectors);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Form = function (_React$Component) {
    _inherits(Form, _React$Component);

    function Form(props) {
        _classCallCheck(this, Form);

        var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

        _this.handleSubmit = _this.handleSubmit.bind(_this);
        return _this;
    }

    Form.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps) {
        return !(0, _helpers.shallowCompare)((0, _formProps.toUpdate)(this.props), (0, _formProps.toUpdate)(nextProps));
    };

    Form.prototype.componentWillMount = function componentWillMount() {
        var _props = this.props,
            name = _props.name,
            _form = _props._form,
            _addForm = _props._addForm;

        if (!_form) {
            _addForm(name);
        }
    };

    Form.prototype.componentWillUnmount = function componentWillUnmount() {
        var _props2 = this.props,
            name = _props2.name,
            persistent = _props2.persistent,
            _removeForm = _props2._removeForm;

        if (!persistent) {
            _removeForm(name);
        }
    };

    Form.prototype.getChildContext = function getChildContext() {
        var name = this.props.name;

        return {
            reduxForms: name
        };
    };

    Form.prototype.handleSubmit = function handleSubmit(ev) {
        var _props3 = this.props,
            name = _props3.name,
            onSubmit = _props3.onSubmit,
            _valid = _props3._valid,
            _values = _props3._values,
            _touchAll = _props3._touchAll,
            _submitting = _props3._submitting,
            _submitStart = _props3._submitStart,
            _submitStop = _props3._submitStop;

        ev.preventDefault();
        _touchAll(name);
        if (_submitting) {
            return;
        }
        if (!_valid || !(0, _helpers.isFunction)(onSubmit)) {
            return;
        }
        var maybePromise = onSubmit(_values);
        if ((0, _helpers.isPromise)(maybePromise)) {
            _submitStart(name);
            maybePromise.then(function () {
                return _submitStop(name);
            });
        }
    };

    Form.prototype.render = function render() {
        var _props4 = this.props,
            children = _props4.children,
            withRef = _props4.withRef,
            _form = _props4._form;
        // Wait until form is initialized

        if (!_form) {
            return null;
        }
        return React.createElement('form', (0, _formProps2.default)((0, _merge2.default)(this.props, {
            ref: withRef,
            onSubmit: this.handleSubmit
        })), children);
    };

    return Form;
}(React.Component);

Form.childContextTypes = {
    reduxForms: React.PropTypes.string.isRequired
};
Form.propTypes = {
    name: React.PropTypes.string.isRequired,
    persistent: React.PropTypes.bool
};
Form.displayName = 'Form';
var bindActions = {
    _addForm: actions.addForm,
    _removeForm: actions.removeForm,
    _touchAll: actions.touchAll,
    _submitStart: actions.submitStart,
    _submitStop: actions.submitStop
};
var Connected = (0, _reactRedux.connect)(function (state, props) {
    return {
        _form: Boolean((0, _prop2.default)(props.name, state.reduxForms)),
        _values: selectors.valueSelector(props.name, state),
        _valid: selectors.isValid(props.name, state),
        _submitting: selectors.isSubmitting(props.name, state)
    };
}, bindActions)(Form);
Connected.displayName = Form.displayName;
exports.default = Connected;